diff --git a/src/xdisp.c b/src/xdisp.c
index fa7691c..aecf3e4 100644
--- a/src/xdisp.c
+++ b/src/xdisp.c
@@ -11214,7 +16317,18 @@ resize_echo_area_exactly (void)
 	{
 	  windows_or_buffers_changed = 42;
 	  update_mode_lines = 30;
-	  redisplay_internal ();
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      mc_redisplay_internal = 1;
+      redisplay_internal (1);
+      mc_redisplay_internal = 0;
+
+/* *************************************************************************** */
+
+
 	}
     }
 }
@@ -11701,7 +16815,18 @@ echo_area_display (bool update_frame_p)
 	      ptrdiff_t count = SPECPDL_INDEX ();
 	      specbind (Qredisplay_dont_pause, Qt);
 	      fset_redisplay (f);
-	      redisplay_internal ();
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+          mc_redisplay_internal = 2;
+          redisplay_internal (2);
+          mc_redisplay_internal = 0;
+
+/* *************************************************************************** */
+
+
 	      unbind_to (count, Qnil);
 	    }
 	  else if (FRAME_WINDOW_P (f) && n == 0)
@@ -13380,6 +18505,19 @@ hscroll_window_tree (Lisp_Object window)
 	      else
 		pt = clip_to_bounds (BEGV, marker_position (w->pointm), ZV);
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  struct display_pos *pos = &cursor_row->start;
+  ptrdiff_t charpos = CHARPOS (pos->pos);
+  bool barf_crash = (charpos < 0 || (charpos >= BUF_BEG (current_buffer) && charpos <= ZV)) ? false : true;
+  if (barf_crash)
+    return hscrolled_p;
+
+/* *************************************************************************** */
+
+
 	      /* Move iterator to pt starting at cursor_row->start in
 		 a line with infinite width.  */
 	      init_to_row_start (&it, w, cursor_row);
@@ -13620,12 +18758,26 @@ text_outside_line_unchanged_p (struct window *w,
    is no longer requested, we clear the echo area or bring back the
    mini-buffer if that is in use.  */
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
 void
-redisplay (void)
+redisplay (int from_where)
 {
-  redisplay_internal ();
+#ifdef GLYPH_DEBUG
+  if (trace_redisplay_p)
+    fprintf (stderr, "\nredisplay (%d)\n", from_where);
+#endif
+  mc_redisplay = from_where;
+  mc_redisplay_internal = 3;
+  redisplay_internal (3);
+  mc_redisplay_internal = 0;
+  mc_redisplay = 0;
 }
 
+/* *************************************************************************** */
+
 
 static Lisp_Object
 overlay_arrow_string_or_property (Lisp_Object var)
@@ -13891,9 +19043,21 @@ do { if (polling_stopped_here) start_polling ();	\
 /* Perhaps in the future avoid recentering windows if it
    is not necessary; currently that causes some problems.  */
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
 static void
-redisplay_internal (void)
+redisplay_internal (int from_where)
 {
+#ifdef GLYPH_DEBUG
+  if (trace_redisplay_p)
+    fprintf (stderr, "\nredisplay_internal (%d)\n", from_where);
+#endif
+
+/* *************************************************************************** */
+
+
   struct window *w = XWINDOW (selected_window);
   struct window *sw;
   struct frame *fr;
@@ -14295,6 +19459,26 @@ redisplay_internal (void)
 #ifdef HAVE_WINDOW_SYSTEM
 	      update_window_fringes (w, false);
 #endif
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+   `w->must_be_updated_p' is set to true within `mc-activate-crosshairs'.
+-  `optimization 1` (e.g., left/right cursor movement on the first screen line).
+-  `optimization 3` (e.g., left/right cursor movement on screen lines subsequent
+    to the first screen line), bypass `redisplay_window'. */
+
+  block_input ();
+  mc_remove_multiple_cursors (w);
+  mc_remove_crosshairs (w);
+  mc_remove_fill_column (w);
+  unblock_input ();
+
+/* *************************************************************************** */
+
+
 	      goto update;
 	    }
 	  else
@@ -14317,6 +19501,22 @@ redisplay_internal (void)
 		  && (w = XWINDOW (selected_window)) != sw)
 		goto retry;
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+   `w->must_be_updated_p' is set to true within `mc-activate-crosshairs'.
+-  `optimization 1` (e.g., left/right cursor movement on the first screen line).
+-  `optimization 3` (e.g., left/right cursor movement on screen lines subsequent
+    to the first screen line), bypass `redisplay_window'. */
+
+    if (w->must_be_updated_p)
+      goto update;
+
+/* *************************************************************************** */
+
+
 	      /* We used to always goto end_of_redisplay here, but this
 		 isn't enough if we have a blinking cursor.  */
 	      if (w->cursor_off_p == w->last_cursor_off_p)
@@ -14358,6 +19558,26 @@ redisplay_internal (void)
 		  *w->desired_matrix->method = 0;
 		  debug_method_add (w, "optimization 3");
 #endif
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+   `w->must_be_updated_p' is set to true within `mc-activate-crosshairs'.
+-  `optimization 1` (e.g., left/right cursor movement on the first screen line).
+-  `optimization 3` (e.g., left/right cursor movement on screen lines subsequent
+    to the first screen line), bypass `redisplay_window'. */
+
+  block_input ();
+  mc_remove_multiple_cursors (w);
+  mc_remove_crosshairs (w);
+  mc_remove_fill_column (w);
+  unblock_input ();
+
+/* *************************************************************************** */
+
+
 		  goto update;
 		}
 	      else
@@ -14738,16 +19958,36 @@ redisplay_preserve_echo_area (int from_where)
   block_buffer_flips ();
   unblock_input ();
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  struct window *w = decode_live_window (selected_window);
+  w->mc.redisplay_preserve_echo_area = from_where;
+  mc_redisplay_preserve_echo_area = from_where;
+
   if (!NILP (echo_area_buffer[1]))
     {
       /* We have a previously displayed message, but no current
 	 message.  Redisplay the previous message.  */
       display_last_displayed_message_p = true;
-      redisplay_internal ();
+      mc_redisplay_internal = 4;
+      redisplay_internal (4);
+      mc_redisplay_internal = 0;
       display_last_displayed_message_p = false;
     }
   else
-    redisplay_internal ();
+    {
+      mc_redisplay_internal = 5;
+      redisplay_internal (5);
+      mc_redisplay_internal = 0;
+    }
+
+  w->mc.redisplay_preserve_echo_area = 0;
+  mc_redisplay_preserve_echo_area = 0;
+
+/* *************************************************************************** */
+
 
   flush_frame (SELECTED_FRAME ());
   unbind_to (count, Qnil);
@@ -17302,6 +22542,25 @@ redisplay_window (Lisp_Object window, bool just_this_one_p)
   debug_method_add (w, "recenter");
 #endif
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+   `w->must_be_updated_p' is set to true within `mc-activate-crosshairs'.
+-  `optimization 1` (e.g., left/right cursor movement on the first screen line).
+-  `optimization 3` (e.g., left/right cursor movement on screen lines subsequent
+    to the first screen line), bypass `redisplay_window'. */
+
+  block_input ();
+  mc_remove_multiple_cursors (w);
+  mc_remove_crosshairs (w);
+  mc_remove_fill_column (w);
+  unblock_input ();
+
+/* *************************************************************************** */
+
+
   /* Forget any previously recorded base line for line number display.  */
   if (!buffer_unchanged_p)
     w->base_line_number = 0;
@@ -17732,6 +22991,25 @@ redisplay_window (Lisp_Object window, bool just_this_one_p)
   else
     TEMP_SET_PT_BOTH (CHARPOS (opoint), BYTEPOS (opoint));
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+/* NOTE:  An idle-timer function may not necessarily trigger `redisplay_window'.
+   `w->must_be_updated_p' is set to true within `mc-activate-crosshairs'.
+-  `optimization 1` (e.g., left/right cursor movement on the first screen line).
+-  `optimization 3` (e.g., left/right cursor movement on screen lines subsequent
+    to the first screen line), bypass `redisplay_window'. */
+
+  block_input ();
+  mc_remove_multiple_cursors (w);
+  mc_remove_crosshairs (w);
+  mc_remove_fill_column (w);
+  unblock_input ();
+
+/* *************************************************************************** */
+
+
   set_buffer_internal_1 (old);
   /* Avoid an abort in TEMP_SET_PT_BOTH if the buffer has become
      shorter.  This can be caused by log truncation in *Messages*.  */
@@ -20122,6 +25400,17 @@ append_space_for_newline (struct it *it, bool default_face_p)
 	  memset (&it->position, 0, sizeof it->position);
 	  it->object = Qnil;
 	  it->c = it->char_to_display = ' ';
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      if (IT_BYTEPOS (*it) >= ZV_BYTE)
+        it->zv_p = true;
+
+/* *************************************************************************** */
+
+
 	  it->len = 1;
 
 	  /* If the default face was remapped, be sure to use the
@@ -21085,6 +26374,21 @@ display_count_lines_visually (struct it *it)
 static void
 maybe_produce_line_number (struct it *it)
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  bool barf_crash = (it->glyph_row == NULL
+                     || it->glyph_row->used[TEXT_AREA] == 0)
+                    ? false
+                    : true;
+  if (barf_crash)
+    return;
+
+/* *************************************************************************** */
+
+
   ptrdiff_t last_line = it->lnum;
   ptrdiff_t start_from, bytepos;
   ptrdiff_t this_line;
@@ -21255,9 +26559,22 @@ maybe_produce_line_number (struct it *it)
       else
 	tem_it.c = tem_it.char_to_display = *p;
       tem_it.len = 1;
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      if (beyond_zv)
+        tem_it.zv_p = true;
+      tem_it.current_y = it->current_y;
+      tem_it.vpos = it->vpos;
       /* Make sure these glyphs will have a "position" of -1.  */
       SET_TEXT_POS (tem_it.position, -1, -1);
       PRODUCE_GLYPHS (&tem_it);
+      tem_it.hpos += 1;
+
+/* *************************************************************************** */
+
 
       /* Stop producing glyphs, and refrain from producing the line
 	 number, if we don't have enough space on this line.  */
@@ -26841,7 +32158,68 @@ draw_glyphs (struct window *w, int x, struct glyph_row *row,
 	 prepended must be drawn because the first glyph string
 	 draws over it.  */
       i = left_overwritten (head);
-      if (i >= 0)
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      bool skip_p = false;
+      int beg = i;
+
+      if (i >= 0
+          && hl == DRAW_CURSOR
+          && (w->mc.glyph_flavor == MC_GLYPH
+              || w->mc.glyph_flavor == MC_GLYPHLESS
+              || w->mc.glyph_flavor == MC_GLYPH_TAB))
+        while (beg < start)
+          {
+            struct glyph *glyph = (row)->glyphs[area] + beg;
+            switch (glyph->type)
+            {
+              case CHAR_GLYPH:
+                break;
+              case COMPOSITE_GLYPH:
+                break;
+              case STRETCH_GLYPH:
+                {
+                  Lisp_Object character = (CHARACTERP (make_fixnum (glyph->u.ch)))
+                                           ? Fchar_to_string (make_fixnum (glyph->u.ch))
+                                           : Qnil;
+                  fprintf (stderr, "\ncharacter (%d | %s)\n",
+                                   glyph->u.ch,
+                                   ((!NILP (character)
+                                     && glyph->u.ch == 1048596)
+                                       ? "\\T"
+                                     : (!NILP (character)
+                                        && glyph->u.ch == 10)
+                                       ? "\\t"
+                                     : (!NILP (character)
+                                        && glyph->u.ch == 10)
+                                       ? "\\n"
+                                     : (!NILP (character)
+                                        && glyph->u.ch == 32)
+                                       ? "\\s"
+                                     : (!NILP (character)
+                                        && glyph->u.ch != 9
+                                        && glyph->u.ch != 10
+                                        && glyph->u.ch != 32)
+                                       ? SSDATA (character)
+                                     : "\\?"));
+                  skip_p = true;
+                  break;
+                }
+              case IMAGE_GLYPH:
+                break;
+            }
+            beg += 1;
+          }
+
+      if (i >= 0
+          && !skip_p)
+
+/* *************************************************************************** */
+
+
 	{
 	  enum draw_glyphs_face overlap_hl;
 
@@ -27069,6 +32447,24 @@ append_glyph (struct it *it)
 	    g[1] = *g;
 	  glyph = it->glyph_row->glyphs[area];
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      glyph->x = it->current_x;
+
+      glyph->y = it->current_y;
+
+      glyph->hpos = it->hpos;
+
+      glyph->vpos = it->vpos;
+
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
       glyph->charpos = CHARPOS (it->position);
       glyph->object = it->object;
       if (it->pixel_width > 0)
@@ -27152,6 +32548,24 @@ append_composite_glyph (struct it *it)
 	    g[1] = *g;
 	  glyph = it->glyph_row->glyphs[it->area];
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      glyph->x = it->current_x;
+
+      glyph->y = it->current_y;
+
+      glyph->hpos = it->hpos;
+
+      glyph->vpos = it->vpos;
+
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
       glyph->charpos = it->cmp_it.charpos;
       glyph->object = it->object;
       eassert (it->pixel_width <= SHRT_MAX);
@@ -27360,6 +32774,24 @@ produce_image_glyph (struct it *it)
 	}
       if (glyph < it->glyph_row->glyphs[area + 1])
 	{
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      glyph->x = it->current_x;
+
+      glyph->y = it->current_y;
+
+      glyph->hpos = it->hpos;
+
+      glyph->vpos = it->vpos;
+
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
 	  glyph->charpos = CHARPOS (it->position);
 	  glyph->object = it->object;
 	  glyph->pixel_width = clip_to_bounds (-1, it->pixel_width, SHRT_MAX);
@@ -27463,6 +32895,24 @@ produce_xwidget_glyph (struct it *it)
 	}
       if (glyph < it->glyph_row->glyphs[area + 1])
 	{
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      glyph->x = it->current_x;
+
+      glyph->y = it->current_y;
+
+      glyph->hpos = it->hpos;
+
+      glyph->vpos = it->vpos;
+
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
 	  glyph->charpos = CHARPOS (it->position);
 	  glyph->object = it->object;
 	  glyph->pixel_width = clip_to_bounds (-1, it->pixel_width, SHRT_MAX);
@@ -27549,6 +32999,24 @@ append_stretch_glyph (struct it *it, Lisp_Object object,
 	    width -= it->first_visible_x - it->current_x;
 	  eassert (width > 0);
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      glyph->x = it->current_x;
+
+      glyph->y = it->current_y;
+
+      glyph->hpos = it->hpos;
+
+      glyph->vpos = it->vpos;
+
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
       glyph->charpos = CHARPOS (it->position);
       glyph->object = object;
       /* FIXME: It would be better to use TYPE_MAX here, but
@@ -28003,6 +33471,24 @@ append_glyphless_glyph (struct it *it, int face_id, bool for_no_font, int len,
 	    g[1] = *g;
 	  glyph = it->glyph_row->glyphs[area];
 	}
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+      glyph->x = it->current_x;
+
+      glyph->y = it->current_y;
+
+      glyph->hpos = it->hpos;
+
+      glyph->vpos = it->vpos;
+
+      glyph->zv_p = it->zv_p;
+
+/* *************************************************************************** */
+
+
       glyph->charpos = CHARPOS (it->position);
       glyph->object = it->object;
       eassert (it->pixel_width <= SHRT_MAX);
@@ -29769,9 +35255,32 @@ display_and_set_cursor (struct window *w, bool on,
       w->phys_cursor.vpos = vpos;
     }
 
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  w->mc.h = -1;
+  w->mc.fx = -1;
+  w->mc.fy = -1;
+  w->mc.glyph_flavor = NO_FLAVOR;
+  w->mc.red = -1.0;
+  w->mc.green = -1.0;
+  w->mc.blue = -1.0;
+  w->mc.posint = -1;
+
   FRAME_RIF (f)->draw_window_cursor (w, glyph_row, x, y,
                                      new_cursor_type, new_cursor_width,
                                      on, active_cursor);
+
+  mc_multiple_cursors_portal (w, on, active_cursor);
+
+  mc_crosshairs_portal (w, on, active_cursor);
+
+  mc_fill_column_portal (w, on, active_cursor);
+
+/* *************************************************************************** */
+
+
 }
 
 
@@ -32528,6 +38037,28 @@ x_intersect_rectangles (XRectangle *r1, XRectangle *r2, XRectangle *result)
 void
 syms_of_xdisp (void)
 {
+
+
+/* *************************************************************************** */
+/* MULTIPLE CURSORS */
+
+  defsubr (&Smc_dump_glyph_row);
+
+  defsubr (&Smc_dump_glyph_matrix);
+
+  defsubr (&Smc_activate_multiple_cursors);
+
+  defsubr (&Smc_activate_crosshairs);
+
+  defsubr (&Smc_stderr);
+
+  defsubr (&Smc_debug);
+
+  defsubr (&Smc_activate_fill_column);
+
+/* *************************************************************************** */
+
+
   Vwith_echo_area_save_vector = Qnil;
   staticpro (&Vwith_echo_area_save_vector);
 
